﻿using System;
using System.Collections;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Text;
using System.Windows.Forms;
using System.Drawing.Drawing2D;
using System.Drawing.Text;
using System.Drawing.Imaging;
using System.Runtime.InteropServices;


namespace BOINC_Challenger
{

    partial class Main
    {

        //----------------------------------------------------------------
        // BOINCBridge
        //----------------------------------------------------------------

        [DllImport("BOINCBridge.dll", CallingConvention = CallingConvention.Cdecl)]
        public static extern int Bridge_Connect();
        [DllImport("BOINCBridge.dll", CallingConvention = CallingConvention.Cdecl)]
        public static extern void Bridge_Disconnect();

        //store

        [DllImport("BOINCBridge.dll", CallingConvention = CallingConvention.Cdecl)]
        public static extern bool 
            Bridge_StoreAll();
        [DllImport("BOINCBridge.dll", CallingConvention = CallingConvention.Cdecl)]
        public static extern bool Bridge_StoreResults();

        //project

        [DllImport("BOINCBridge.dll", CallingConvention = CallingConvention.Cdecl)]
        public static extern int Bridge_GetNumberofProjects();
        [DllImport("BOINCBridge.dll", CallingConvention = CallingConvention.Cdecl)]
        public static extern int Bridge_GetProject(int projectNr, StringBuilder prjName, StringBuilder totWUS, StringBuilder taskState, StringBuilder userName, StringBuilder totCredits);
        [DllImport("BOINCBridge.dll", CallingConvention = CallingConvention.Cdecl)]
        public static extern int Bridge_GetProjectColor(int prjId);

        //task

        [DllImport("BOINCBridge.dll", CallingConvention = CallingConvention.Cdecl)]
        public static extern int Bridge_GetNumberofTask();
        [DllImport("BOINCBridge.dll", CallingConvention = CallingConvention.Cdecl)]
        public static extern int Bridge_GetTask(int taskNr,StringBuilder prjName,StringBuilder appName,StringBuilder taskName,StringBuilder taskState,StringBuilder fractionDone);
        [DllImport("BOINCBridge.dll", CallingConvention = CallingConvention.Cdecl)]
        public static extern int Bridge_GetTaskColor(int taskId);
        
        //command

        [DllImport("BOINCBridge.dll", CallingConvention = CallingConvention.Cdecl)]
        public static extern int Bridge_SetCommand(int mode, int id, int command);
        [DllImport("BOINCBridge.dll", CallingConvention = CallingConvention.Cdecl)]
        public static extern int Bridge_SetCPU(bool active); 
		[DllImport("BOINCBridge.dll", CallingConvention = CallingConvention.Cdecl)]
        public static extern int  Bridge_SetGPU(bool active); 

        //----------------------------------------------------------------
        // 
        //----------------------------------------------------------------

        
        private System.ComponentModel.IContainer components = null;

        protected override void Dispose(bool disposing)
        {
            Bridge_Disconnect();

            if (disposing && (components != null))
                components.Dispose();

            base.Dispose(disposing);
        }

        #region Windows Form Designer generated code

        private void InitializeComponent()
        {
            this.components = new System.ComponentModel.Container();
            this.taskList = new System.Windows.Forms.ListView();
            this.Project = ((System.Windows.Forms.ColumnHeader)(new System.Windows.Forms.ColumnHeader()));
            this.State = ((System.Windows.Forms.ColumnHeader)(new System.Windows.Forms.ColumnHeader()));
            this.FractionDone = ((System.Windows.Forms.ColumnHeader)(new System.Windows.Forms.ColumnHeader()));
            this.AppName = ((System.Windows.Forms.ColumnHeader)(new System.Windows.Forms.ColumnHeader()));
            this.WUName = ((System.Windows.Forms.ColumnHeader)(new System.Windows.Forms.ColumnHeader()));
            this.projectList = new System.Windows.Forms.ListView();
            this.columnHeader1 = ((System.Windows.Forms.ColumnHeader)(new System.Windows.Forms.ColumnHeader()));
            this.columnHeader2 = ((System.Windows.Forms.ColumnHeader)(new System.Windows.Forms.ColumnHeader()));
            this.columnHeader3 = ((System.Windows.Forms.ColumnHeader)(new System.Windows.Forms.ColumnHeader()));
            this.columnHeader4 = ((System.Windows.Forms.ColumnHeader)(new System.Windows.Forms.ColumnHeader()));
            this.columnHeader5 = ((System.Windows.Forms.ColumnHeader)(new System.Windows.Forms.ColumnHeader()));
            this.menuStrip1 = new System.Windows.Forms.MenuStrip();
            this.fileToolStripMenuItem = new System.Windows.Forms.ToolStripMenuItem();
            this.cPUToolStripMenuItem = new System.Windows.Forms.ToolStripMenuItem();
            this.gPUToolStripMenuItem = new System.Windows.Forms.ToolStripMenuItem();
            this.toolStripSeparator2 = new System.Windows.Forms.ToolStripSeparator();
            this.aboutToolStripMenuItem = new System.Windows.Forms.ToolStripMenuItem();
            this.toolStripSeparator1 = new System.Windows.Forms.ToolStripSeparator();
            this.quitToolStripMenuItem = new System.Windows.Forms.ToolStripMenuItem();
            this.buttonSuspend = new System.Windows.Forms.Button();
            this.buttonResume = new System.Windows.Forms.Button();
            this.UpdateTimer = new System.Windows.Forms.Timer(this.components);
            this.StopAt = new System.Windows.Forms.Button();
            this.comboBox1 = new System.Windows.Forms.ComboBox();
            this.buttonUpdate = new System.Windows.Forms.Button();
            this.buttonWork = new System.Windows.Forms.Button();
            this.buttonAllowWork = new System.Windows.Forms.Button();
            this.menuStrip1.SuspendLayout();
            this.SuspendLayout();
            // 
            // taskList
            // 
            this.taskList.AllowColumnReorder = true;
            this.taskList.Anchor = ((System.Windows.Forms.AnchorStyles)((((System.Windows.Forms.AnchorStyles.Top | System.Windows.Forms.AnchorStyles.Bottom) 
            | System.Windows.Forms.AnchorStyles.Left) 
            | System.Windows.Forms.AnchorStyles.Right)));
            this.taskList.Columns.AddRange(new System.Windows.Forms.ColumnHeader[] {
            this.Project,
            this.State,
            this.FractionDone,
            this.AppName,
            this.WUName});
            this.taskList.FullRowSelect = true;
            this.taskList.GridLines = true;
            this.taskList.HideSelection = false;
            this.taskList.Location = new System.Drawing.Point(715, 40);
            this.taskList.Name = "taskList";
            this.taskList.ShowGroups = false;
            this.taskList.Size = new System.Drawing.Size(469, 588);
            this.taskList.TabIndex = 1;
            this.taskList.UseCompatibleStateImageBehavior = false;
            this.taskList.View = System.Windows.Forms.View.Details;
            // 
            // Project
            // 
            this.Project.Text = "Project";
            this.Project.Width = 180;
            // 
            // State
            // 
            this.State.Text = "State";
            this.State.Width = 137;
            // 
            // FractionDone
            // 
            this.FractionDone.Text = "Progress";
            this.FractionDone.Width = 120;
            // 
            // AppName
            // 
            this.AppName.Text = "AppName";
            this.AppName.Width = 159;
            // 
            // WUName
            // 
            this.WUName.Text = "WU Name";
            this.WUName.Width = 158;
            // 
            // projectList
            // 
            this.projectList.AllowColumnReorder = true;
            this.projectList.Anchor = ((System.Windows.Forms.AnchorStyles)(((System.Windows.Forms.AnchorStyles.Top | System.Windows.Forms.AnchorStyles.Bottom) 
            | System.Windows.Forms.AnchorStyles.Left)));
            this.projectList.Columns.AddRange(new System.Windows.Forms.ColumnHeader[] {
            this.columnHeader1,
            this.columnHeader2,
            this.columnHeader3,
            this.columnHeader4,
            this.columnHeader5});
            this.projectList.FullRowSelect = true;
            this.projectList.GridLines = true;
            this.projectList.HideSelection = false;
            this.projectList.Location = new System.Drawing.Point(13, 40);
            this.projectList.Name = "projectList";
            this.projectList.ShowGroups = false;
            this.projectList.Size = new System.Drawing.Size(696, 553);
            this.projectList.TabIndex = 2;
            this.projectList.UseCompatibleStateImageBehavior = false;
            this.projectList.View = System.Windows.Forms.View.Details;
            // 
            // columnHeader1
            // 
            this.columnHeader1.Text = "Project";
            this.columnHeader1.Width = 159;
            // 
            // columnHeader2
            // 
            this.columnHeader2.Text = "WUs";
            this.columnHeader2.Width = 73;
            // 
            // columnHeader3
            // 
            this.columnHeader3.Text = "State";
            this.columnHeader3.Width = 135;
            // 
            // columnHeader4
            // 
            this.columnHeader4.Text = "User";
            this.columnHeader4.Width = 191;
            // 
            // columnHeader5
            // 
            this.columnHeader5.Text = "Credits";
            this.columnHeader5.Width = 132;
            // 
            // menuStrip1
            // 
            this.menuStrip1.BackgroundImageLayout = System.Windows.Forms.ImageLayout.None;
            this.menuStrip1.Items.AddRange(new System.Windows.Forms.ToolStripItem[] {
            this.fileToolStripMenuItem});
            this.menuStrip1.Location = new System.Drawing.Point(0, 0);
            this.menuStrip1.Name = "menuStrip1";
            this.menuStrip1.Size = new System.Drawing.Size(1196, 28);
            this.menuStrip1.TabIndex = 3;
            this.menuStrip1.Text = "menuStrip1";
            // 
            // fileToolStripMenuItem
            // 
            this.fileToolStripMenuItem.DropDownItems.AddRange(new System.Windows.Forms.ToolStripItem[] {
            this.cPUToolStripMenuItem,
            this.gPUToolStripMenuItem,
            this.toolStripSeparator2,
            this.aboutToolStripMenuItem,
            this.toolStripSeparator1,
            this.quitToolStripMenuItem});
            this.fileToolStripMenuItem.Name = "fileToolStripMenuItem";
            this.fileToolStripMenuItem.Size = new System.Drawing.Size(44, 24);
            this.fileToolStripMenuItem.Text = "File";
            // 
            // cPUToolStripMenuItem
            // 
            this.cPUToolStripMenuItem.Checked = true;
            this.cPUToolStripMenuItem.CheckState = System.Windows.Forms.CheckState.Checked;
            this.cPUToolStripMenuItem.Name = "cPUToolStripMenuItem";
            this.cPUToolStripMenuItem.Size = new System.Drawing.Size(128, 24);
            this.cPUToolStripMenuItem.Text = "CPU";
            this.cPUToolStripMenuItem.Click += new System.EventHandler(this.cPUToolStripMenuItem_Click);
            // 
            // gPUToolStripMenuItem
            // 
            this.gPUToolStripMenuItem.Checked = true;
            this.gPUToolStripMenuItem.CheckState = System.Windows.Forms.CheckState.Checked;
            this.gPUToolStripMenuItem.Name = "gPUToolStripMenuItem";
            this.gPUToolStripMenuItem.Size = new System.Drawing.Size(128, 24);
            this.gPUToolStripMenuItem.Text = "GPU";
            this.gPUToolStripMenuItem.Click += new System.EventHandler(this.gPUToolStripMenuItem_Click);
            // 
            // toolStripSeparator2
            // 
            this.toolStripSeparator2.Name = "toolStripSeparator2";
            this.toolStripSeparator2.Size = new System.Drawing.Size(125, 6);
            // 
            // aboutToolStripMenuItem
            // 
            this.aboutToolStripMenuItem.Name = "aboutToolStripMenuItem";
            this.aboutToolStripMenuItem.Size = new System.Drawing.Size(128, 24);
            this.aboutToolStripMenuItem.Text = "About...";
            this.aboutToolStripMenuItem.Click += new System.EventHandler(this.aboutToolStripMenuItem_Click);
            // 
            // toolStripSeparator1
            // 
            this.toolStripSeparator1.Name = "toolStripSeparator1";
            this.toolStripSeparator1.Size = new System.Drawing.Size(125, 6);
            // 
            // quitToolStripMenuItem
            // 
            this.quitToolStripMenuItem.Name = "quitToolStripMenuItem";
            this.quitToolStripMenuItem.Size = new System.Drawing.Size(128, 24);
            this.quitToolStripMenuItem.Text = "Quit";
            this.quitToolStripMenuItem.Click += new System.EventHandler(this.quitToolStripMenuItem_Click);
            // 
            // buttonSuspend
            // 
            this.buttonSuspend.Anchor = ((System.Windows.Forms.AnchorStyles)((System.Windows.Forms.AnchorStyles.Bottom | System.Windows.Forms.AnchorStyles.Left)));
            this.buttonSuspend.Location = new System.Drawing.Point(13, 602);
            this.buttonSuspend.Name = "buttonSuspend";
            this.buttonSuspend.Size = new System.Drawing.Size(93, 28);
            this.buttonSuspend.TabIndex = 4;
            this.buttonSuspend.Text = "Suspend";
            this.buttonSuspend.UseVisualStyleBackColor = true;
            this.buttonSuspend.Click += new System.EventHandler(this.buttonSuspend_Click);
            // 
            // buttonResume
            // 
            this.buttonResume.Anchor = ((System.Windows.Forms.AnchorStyles)((System.Windows.Forms.AnchorStyles.Bottom | System.Windows.Forms.AnchorStyles.Left)));
            this.buttonResume.Location = new System.Drawing.Point(264, 603);
            this.buttonResume.Name = "buttonResume";
            this.buttonResume.Size = new System.Drawing.Size(82, 28);
            this.buttonResume.TabIndex = 5;
            this.buttonResume.Text = "Resume";
            this.buttonResume.UseVisualStyleBackColor = true;
            this.buttonResume.Click += new System.EventHandler(this.buttonResume_Click);
            // 
            // UpdateTimer
            // 
            this.UpdateTimer.Enabled = true;
            this.UpdateTimer.Interval = 10000;
            this.UpdateTimer.Tick += new System.EventHandler(this.OnTimedEvent);
            // 
            // StopAt
            // 
            this.StopAt.Anchor = ((System.Windows.Forms.AnchorStyles)((System.Windows.Forms.AnchorStyles.Bottom | System.Windows.Forms.AnchorStyles.Left)));
            this.StopAt.Location = new System.Drawing.Point(111, 603);
            this.StopAt.Name = "StopAt";
            this.StopAt.Size = new System.Drawing.Size(79, 28);
            this.StopAt.TabIndex = 6;
            this.StopAt.Text = "Stop at";
            this.StopAt.UseVisualStyleBackColor = true;
            this.StopAt.Click += new System.EventHandler(this.StopAt_Click);
            // 
            // comboBox1
            // 
            this.comboBox1.Anchor = ((System.Windows.Forms.AnchorStyles)((System.Windows.Forms.AnchorStyles.Bottom | System.Windows.Forms.AnchorStyles.Left)));
            this.comboBox1.DropDownStyle = System.Windows.Forms.ComboBoxStyle.DropDownList;
            this.comboBox1.FormattingEnabled = true;
            this.comboBox1.Items.AddRange(new object[] {
            "50%",
            "60%",
            "70%",
            "80%",
            "90%"});
            this.comboBox1.Location = new System.Drawing.Point(196, 604);
            this.comboBox1.Name = "comboBox1";
            this.comboBox1.Size = new System.Drawing.Size(62, 24);
            this.comboBox1.TabIndex = 7;
            // 
            // buttonUpdate
            // 
            this.buttonUpdate.Anchor = ((System.Windows.Forms.AnchorStyles)((System.Windows.Forms.AnchorStyles.Bottom | System.Windows.Forms.AnchorStyles.Left)));
            this.buttonUpdate.Location = new System.Drawing.Point(373, 603);
            this.buttonUpdate.Name = "buttonUpdate";
            this.buttonUpdate.Size = new System.Drawing.Size(82, 28);
            this.buttonUpdate.TabIndex = 8;
            this.buttonUpdate.Text = "Update";
            this.buttonUpdate.UseVisualStyleBackColor = true;
            this.buttonUpdate.Click += new System.EventHandler(this.buttonUpdate_Click);
            // 
            // buttonWork
            // 
            this.buttonWork.Anchor = ((System.Windows.Forms.AnchorStyles)((System.Windows.Forms.AnchorStyles.Bottom | System.Windows.Forms.AnchorStyles.Left)));
            this.buttonWork.Location = new System.Drawing.Point(481, 603);
            this.buttonWork.Name = "buttonWork";
            this.buttonWork.Size = new System.Drawing.Size(111, 28);
            this.buttonWork.TabIndex = 9;
            this.buttonWork.Text = "No more WUs";
            this.buttonWork.UseVisualStyleBackColor = true;
            this.buttonWork.Click += new System.EventHandler(this.buttonWork_Click);
            // 
            // buttonAllowWork
            // 
            this.buttonAllowWork.Anchor = ((System.Windows.Forms.AnchorStyles)((System.Windows.Forms.AnchorStyles.Bottom | System.Windows.Forms.AnchorStyles.Left)));
            this.buttonAllowWork.Location = new System.Drawing.Point(598, 601);
            this.buttonAllowWork.Name = "buttonAllowWork";
            this.buttonAllowWork.Size = new System.Drawing.Size(111, 28);
            this.buttonAllowWork.TabIndex = 10;
            this.buttonAllowWork.Text = "Allow new WUs";
            this.buttonAllowWork.UseVisualStyleBackColor = true;
            this.buttonAllowWork.Click += new System.EventHandler(this.buttonAllowWork_Click);
            // 
            // Main
            // 
            this.AutoScaleMode = System.Windows.Forms.AutoScaleMode.None;
            this.BackColor = System.Drawing.SystemColors.Control;
            this.ClientSize = new System.Drawing.Size(1196, 650);
            this.Controls.Add(this.buttonAllowWork);
            this.Controls.Add(this.buttonWork);
            this.Controls.Add(this.buttonUpdate);
            this.Controls.Add(this.comboBox1);
            this.Controls.Add(this.StopAt);
            this.Controls.Add(this.buttonResume);
            this.Controls.Add(this.buttonSuspend);
            this.Controls.Add(this.projectList);
            this.Controls.Add(this.taskList);
            this.Controls.Add(this.menuStrip1);
            this.DoubleBuffered = true;
            this.MainMenuStrip = this.menuStrip1;
            this.Name = "Main";
            this.ShowIcon = false;
            this.StartPosition = System.Windows.Forms.FormStartPosition.CenterScreen;
            this.Text = "BOINCChallenger";
            this.menuStrip1.ResumeLayout(false);
            this.menuStrip1.PerformLayout();
            this.ResumeLayout(false);
            this.PerformLayout();

        }

        #endregion

        private ListView taskList;
        private ColumnHeader Project;
        private ColumnHeader WUName;
        private ColumnHeader State;
        private ColumnHeader AppName;
        private ListView projectList;
        private ColumnHeader columnHeader1;
        private ColumnHeader columnHeader2;
        private ColumnHeader columnHeader3;
        private MenuStrip menuStrip1;
        private ToolStripMenuItem fileToolStripMenuItem;
        private ToolStripMenuItem aboutToolStripMenuItem;
        private ToolStripMenuItem quitToolStripMenuItem;
        private ToolStripSeparator toolStripSeparator1;
        private ColumnHeader columnHeader4;
        private ColumnHeader columnHeader5;
        private Button buttonSuspend;
        private Button buttonResume;
        private ColumnHeader FractionDone;
        private Timer UpdateTimer;
        private Button StopAt;
        private ComboBox comboBox1;
        private Button buttonUpdate;
        private Button buttonWork;
        private Button buttonAllowWork;
        private ToolStripMenuItem cPUToolStripMenuItem;
        private ToolStripMenuItem gPUToolStripMenuItem;
        private ToolStripSeparator toolStripSeparator2;

    }

    

}

