﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Linq;
using System.Text;
using System.Threading.Tasks;
using System.Windows.Forms;
using System.Runtime.InteropServices;
using System.Collections;
using System.Timers;

namespace BOINC_Challenger
{

    //-----------------------------------------------------------------------
    // MAIN
    //-----------------------------------------------------------------------

    public partial class Main : Form
    {

        public enum MySortOrder { Descending = -1, None, Ascending };
        private MySortOrder p_order = MySortOrder.None;
        private MySortOrder t_order = MySortOrder.None;
        private int curr_column_task = -1;
        private int curr_column_prj = -1;

        //-----------------------------------------------------------------------
        // aggiorna le liste dopo Bridge_Store();
        //-----------------------------------------------------------------------

        private void FillList()
        {
            //PROJECTS
            int totRows = Bridge_GetNumberofProjects();

            StringBuilder prjName = new StringBuilder(255);
            StringBuilder totWUS = new StringBuilder(255);
            StringBuilder prjState = new StringBuilder(255);
            StringBuilder userName = new StringBuilder(255);
            StringBuilder totCredits = new StringBuilder(255);

            //se la lunghezza lista non coincide cleara tutto
            if (totRows != projectList.Items.Count)
                projectList.Items.Clear();

            for (int i = 0; i < totRows; i++)
            {
                int pid = Bridge_GetProject(i, prjName, totWUS, prjState,userName, totCredits);
                int state = Bridge_GetProjectColor(i);

                //controlla se esiste
                int found = -1;
                for (int p = 0; p < projectList.Items.Count; p++)
                    if (projectList.Items[p].SubItems[0].Text == prjName.ToString())
                    {
                        found = p;
                        break;
                    }

                ListViewItem item1;

                //se esiste sostituisce 
                if (found >= 0)
                {
                    item1 = projectList.Items[found];
                    item1.SubItems[1].Text = totWUS.ToString();
                    item1.SubItems[2].Text = prjState.ToString();
                }
                else
                {    
                    item1 = new ListViewItem(prjName.ToString());   //0
                    item1.SubItems.Add(totWUS.ToString());          //1
                    item1.SubItems.Add(prjState.ToString());        //2
                    item1.SubItems.Add(userName.ToString());        //3
                    item1.SubItems.Add(totCredits.ToString());      //4
                    item1.Tag = i; //unique ID?
                }

                item1.UseItemStyleForSubItems = true;
                if (state== 1)
                    item1.SubItems[0].BackColor = Color.FromArgb(255, 200, 200); //suspended
                else if (state == 2) 
                    item1.SubItems[0].BackColor = Color.FromArgb(200,200,200);   //dont_request_more_work
                else if (state == 3) 
                    item1.SubItems[0].BackColor = Color.FromArgb(255,255,255);   //scheduler in progress
                else if (state == 7) 
                    item1.SubItems[0].BackColor = Color.FromArgb(230, 230, 255);  //USER STATE stop_at
                else
                    item1.SubItems[0].BackColor = Color.FromArgb(255,255,255);   //

                if (found < 0)
                    projectList.Items.Add(item1);
            }

            //TASK

            StringBuilder taskName = new StringBuilder(255);
            StringBuilder tprjName = new StringBuilder(255);
            StringBuilder appName = new StringBuilder(255);
            StringBuilder taskState = new StringBuilder(30);
            StringBuilder fractionDone = new StringBuilder(20);

            //se la lunghezza lista non coincide cleara tutto
            totRows = Bridge_GetNumberofTask();
            if (totRows != taskList.Items.Count)
                taskList.Items.Clear();

            for (int i=0; i<totRows; i++)
            {
                int pid = Bridge_GetTask(i, tprjName, appName, taskName, taskState, fractionDone);

                //controlla se esiste
                int found = -1;
                for (int p = 0; p < taskList.Items.Count; p++)
                    if (taskList.Items[p].SubItems[4].Text == taskName.ToString())
                    {
                        found = p;
                        break;
                    }

                ListViewItem item1;

                //se esiste sostituisce 
                if (found >= 0)
                {
                    item1 = taskList.Items[found];
                    item1.SubItems[1].Text = taskState.ToString();
                    item1.SubItems[2].Text = fractionDone.ToString();
                }
                else
                {
                    item1 = new ListViewItem(tprjName.ToString());  //0
                    item1.SubItems.Add(taskState.ToString());       //1
                    item1.SubItems.Add(fractionDone.ToString());    //2
                    item1.SubItems.Add(appName.ToString());         //3
                    item1.SubItems.Add(taskName.ToString());        //4
                    item1.Tag = i;
                }

                item1.UseItemStyleForSubItems = true;
                int state = Bridge_GetTaskColor(i);
                if (state == 0)
                    item1.SubItems[0].BackColor = Color.FromArgb(240, 255, 240);  //active_task
                else if (state == 1)
                    item1.SubItems[0].BackColor = Color.FromArgb(255, 255, 255);  //network_wait
                else if (state == 2)
                    item1.SubItems[0].BackColor = Color.FromArgb(200, 255, 200);  //ready_to_report
                else if (state == 3)
                    item1.SubItems[0].BackColor = Color.FromArgb(255, 200, 200);  //suspended_via_gui
                else if (state == 4)
                    item1.SubItems[0].BackColor = Color.FromArgb(255, 200, 200);  //suspended_via_prj
                else if (state == 5)
                    item1.SubItems[0].BackColor = Color.FromArgb(255, 255, 255);  //scheduler_wait
                else if (state == 6)
                    item1.SubItems[0].BackColor = Color.FromArgb(255, 255, 200);  //waiting to run
                else if (state == 7)
                    item1.SubItems[0].BackColor = Color.FromArgb(230, 230, 255);  //USER STATE stop_at
                else
                    item1.SubItems[0].BackColor = Color.FromArgb(255, 255, 255);

                if (found < 0)
                    taskList.Items.Add(item1);
            }
        }

        //-----------------------------------------------------------------------
        // 
        //-----------------------------------------------------------------------

        //TIMER
        void OnTimedEvent(object Sender, EventArgs e)
        {
            if (Bridge_StoreAll())
                FillList();
        }

        //-----------------------------------------------------------------------
        // 
        //-----------------------------------------------------------------------

       

        public Main()
        {
            InitializeComponent();

            //si setta al 50%
            comboBox1.SelectedIndex = 0;

            //per il sort della lista progetti
            this.projectList.ColumnClick += (object sender, ColumnClickEventArgs e) =>
            {

                if (curr_column_prj != e.Column)
                    p_order = MySortOrder.Ascending;
                else
                    p_order = (int)++p_order > 1 ? MySortOrder.Descending : p_order;

                this.projectList.ListViewItemSorter = new ItemComparer(e.Column, (int)p_order);
                curr_column_prj = e.Column;
            };

            //per il sort della lista WUs
            this.taskList.ColumnClick += (object sender, ColumnClickEventArgs e) =>
            {
                if (curr_column_task != e.Column)
                    t_order = MySortOrder.Ascending;
                else
                    t_order = (int)++t_order > 1 ? MySortOrder.Descending : t_order;
                this.taskList.ListViewItemSorter = new ItemComparer(e.Column, (int)t_order);
                curr_column_task = e.Column;
            };

            if (Bridge_Connect() == 0)
            {
                Dispose(true);
                return;
            }
            if (Bridge_StoreAll())
                FillList();
        }

        

        //-----------------------------------------------------------------------
        // menu
        //-----------------------------------------------------------------------

        private void aboutToolStripMenuItem_Click(object sender, EventArgs e)
        {
            About stiKazz = new About();
            stiKazz.ShowDialog();
        }

        //in CHIUSURA finestra salva tutto
        private void Main_FormClosing(object sender, FormClosingEventArgs e)
        {
            
        }

        private void quitToolStripMenuItem_Click(object sender, EventArgs e)
        {
            this.Close();
        }

        // COMANDI
        private void SendProjectCommand(int cmd)
        {
            for (int i = 0; i < projectList.SelectedIndices.Count; i++)
            {
                ListViewItem selectedItem = projectList.Items[projectList.SelectedIndices[i]];
                int projectID = (int)selectedItem.Tag;
                Bridge_SetCommand(0, projectID, cmd);
            }

            if (Bridge_StoreAll())
                FillList();
        }

        //0=suspend 1=resume 2=nomorework 3=allowwork 4=update 5=reset 6=USER
        private void buttonSuspend_Click(object sender, EventArgs e){ SendProjectCommand(0); }
        private void buttonResume_Click(object sender, EventArgs e) { SendProjectCommand(1); }
        private void buttonWork_Click(object sender, EventArgs e) { SendProjectCommand(2); }
        private void buttonAllowWork_Click(object sender, EventArgs e) { SendProjectCommand(3); }
        private void buttonUpdate_Click(object sender, EventArgs e) { SendProjectCommand(4); }
        
        //6=USER STATE stop_at
        private void StopAt_Click(object sender, EventArgs e)
        {
            int percentage = comboBox1.SelectedIndex;
            if (percentage == 0) SendProjectCommand(50);
            if (percentage == 1) SendProjectCommand(60);
            if (percentage == 2) SendProjectCommand(70);
            if (percentage == 3) SendProjectCommand(80);
            if (percentage == 4) SendProjectCommand(90);
            if (Bridge_StoreAll())
                FillList();
        }

        private void cPUToolStripMenuItem_Click(object sender, EventArgs e)
        {
            if (!cPUToolStripMenuItem.Checked)
                cPUToolStripMenuItem.Checked = true;
            else
                cPUToolStripMenuItem.Checked = false;

            if (cPUToolStripMenuItem.Checked)
            {
                gPUToolStripMenuItem.Enabled = true;
                Bridge_SetCPU(true);
            }
            else
            {
                gPUToolStripMenuItem.Enabled = false;
                Bridge_SetCPU(false);
            }
        }

        private void gPUToolStripMenuItem_Click(object sender, EventArgs e)
        {
            if (gPUToolStripMenuItem.Checked)
            {
                gPUToolStripMenuItem.Checked = false;
                Bridge_SetGPU(false);
            }
            else
            {
                gPUToolStripMenuItem.Checked = true;
                Bridge_SetGPU(true);
            }
        }
    }

    //-----------------------------------------------------------------------
    // SORTER
    //-----------------------------------------------------------------------

    class ItemComparer : IComparer
    {
        private int _index;
        private int _order;

        public ItemComparer(int index, int order)
        {
            _index = index;
            _order = order;
        }

        public int Compare(object A, object B)
        {
            if (_order == 0 || A == B) return 0;
            else if (A == null) return -1;
            else if (B == null) return 1;

            ListViewItem itemA = A as ListViewItem;
            ListViewItem itemB = B as ListViewItem;

            if (itemA.SubItems[_index].Text == itemB.SubItems[_index].Text)
                return 0;

            DateTime dateA, dateB;

            if (DateTime.TryParse(itemA.SubItems[_index].Text, out dateA) &&
                DateTime.TryParse(itemB.SubItems[_index].Text, out dateB))
                    return _order * DateTime.Compare(dateA, dateB);

            double doubleA, doubleB;

            if (double.TryParse(itemA.SubItems[_index].Text, out doubleA) &&
                double.TryParse(itemB.SubItems[_index].Text, out doubleB))
                    return _order * doubleA > doubleB ? 1 : (doubleA < doubleB ? -1 : 0);

            return _order * String.Compare(itemA.SubItems[_index].Text,itemB.SubItems[_index].Text);
        }
    }

}//end namespace BOINC_Challenger
